#include "time_util.h"
#include <stdio.h>
  
/* ----------------------------------------------------- */
/* returns the gap between high timeval to low timeval   */   
struct timeval t_minus ( struct timeval high , struct timeval low )
{
  struct timeval gap;

  gap.tv_sec = high.tv_sec - low.tv_sec;
  gap.tv_usec = high.tv_usec - low.tv_usec;

  if (( gap.tv_sec < 0 )  /* some error occured */
      || ((gap.tv_sec == 0) && ( gap.tv_usec < 0 )))
      {
        gap.tv_sec = 0;
        gap.tv_usec = 0;
      }
  else if ( gap.tv_usec < 0 ) /* this means : high.micro < low.micro */
    {
      gap.tv_sec--;
      gap.tv_usec += 999999; /* complimentry to full second in micro */
    }
  return ( gap );
}

struct timeval get_avg_time(struct timeval total_time, int iter)
{
  struct timeval avg;

  long int total_msecs = total_time.tv_sec * 1000000+ total_time.tv_usec;
  total_msecs /= iter;
  avg.tv_sec = total_msecs / 1000000;
  avg.tv_usec = total_msecs % 1000000;
  return avg;
}



