#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <assert.h>
#include "time_util.h"

#define MAX_ITERATIONS 10000000
#define MAX_THRESHOLDS 13
static double g_results[MAX_ITERATIONS];
int g_thresh[MAX_THRESHOLDS] = { 1, 2, 3, 4, 5, 7, 10, 50, 100, 1000, 10000 , 20000, 50000};
int g_thresh_count[MAX_THRESHOLDS];
  
void main(int argc, char **argv)
{
  struct timeval time1, time2, diff;
  long sum_difs = 0;
  double avg_difs, stddev, sum = 0,max = 0, min = MAX_ITERATIONS;

  int iter, i,j;
  if (argc != 2) {
    fprintf(stderr, "Usage: %s <number of iterations>\n", argv[0]);
    exit(1);
  }

  /* calculate average difference */
  iter = atoi (argv[1]);
  for (i=0; i<iter; i++){
    gettimeofday(&time1, NULL);
    gettimeofday(&time2, NULL);
    diff = t_minus(time2, time1);
    assert (diff.tv_usec >= 0);

    for (j=0; j<MAX_THRESHOLDS; j++)
      if (diff.tv_usec<g_thresh[j]) {
	g_thresh_count[j]++;
	break;
      }
    if (diff.tv_usec > max)
      max = diff.tv_usec;
    if (diff.tv_usec < min)
      min = diff.tv_usec;
    g_results[i] = diff.tv_usec;
    sum_difs += diff.tv_usec;
  }
  avg_difs = (sum_difs / ((float)iter)); /* calculate average */
  
  /* calculate stddev */
  for (i=0; i<iter; i++){
    sum += (g_results[i]-avg_difs)*(g_results[i]-avg_difs);
  }
  fprintf(stderr, "sum = %f\n", sum);
  fprintf(stderr, "iter = %d\n", iter);
  stddev = sqrt(sum / (float)iter);

  fprintf(stderr, "average difference between two successive calls to gettimeofday() is %3.3f microseconds.\n" ,avg_difs);
  fprintf(stderr, "maximum time: %3.3f\n", max);
  fprintf(stderr, "minumum time: %3.3f\n", min);
  fprintf(stderr, "Standard Deviation: %3.3f\n", stddev);
  fprintf(stderr, "Histogram :\n");
  for (j=0; j<MAX_THRESHOLDS; j++) {
    if (j>0)
      fprintf (stderr, ">=%d <%d: %d\n", g_thresh[j-1], g_thresh[j], g_thresh_count[j]);
    else
      fprintf (stderr, "< %d : %d\n", g_thresh[j], g_thresh_count[j]);
  }
}







