#define BILLION  1000000000L
#define MILLION 1000000L

#include "time_util.h"
  
/* ----------------------------------------------------- */
/* returns the gap between high timespec to low timespec   */   
struct timespec t_minus ( struct timespec high , struct timespec low)
{
  struct timespec gap;

  gap.tv_sec = high.tv_sec - low.tv_sec;
  gap.tv_nsec = high.tv_nsec - low.tv_nsec;

  if (( gap.tv_sec < 0 )  /* some error occured */
      || ((gap.tv_sec == 0) && ( gap.tv_nsec < 0 )))
      {
        gap.tv_sec = 0;
        gap.tv_nsec = 0;
      }
  else if ( gap.tv_nsec < 0 ) /* this means : high.nano < low.nano */
    {
      gap.tv_sec--;
      gap.tv_nsec += BILLION; /* complimentry to full second in nano */
    }
  return ( gap );
}

struct timespec get_avg_time(struct timespec total_time, int iter)
{
  struct timespec avg;

  long int total_msecs = total_time.tv_sec * MILLION+ total_time.tv_nsec/1000; //total microseconds
  total_msecs /= iter;
  avg.tv_sec = total_msecs / MILLION;
  avg.tv_nsec = (total_msecs % MILLION)*1000;
  return avg;
}


struct timespec nano2micro(struct timespec time1)
{
	struct timespec res;
	
	res.tv_sec = time1.tv_sec;
	res.tv_nsec = time1.tv_nsec / 1000;
	
	return res;
}


