#!/usr/bin/perl -w

if  (($#ARGV != 1) && ($#ARGV != 2)) {
  die "usage: tcp_test <hostname> <port> [NT (y/n)]\n";
}

if ($#ARGV == 2){
  if (($ARGV[3] != "y") && ($ARGV[3] != "n")){
    die "usage: tcp_test <hostname> <port> [output file] [NT (y/n)]\n";
  }
}

#location of netperf
$netperf = "netperf"; 
 
# confidence level
$confidence1 = "-i5,2";
$confidence2 = "-I95,5";

# define a TCP test
$test_type = "-tTCP_STREAM";

# maximum time for the test
$max_time = "-l30"; 

#Recv and Send socket size in bytes
$recv_sock_size = "-S131072";
$send_sock_size = "-s131072";
 
# minumum message size
$min_send_size = 1;

#maximum message size
$max_send_size = 131072;

#Set host name
$host = "-H" . $ARGV[0]; 

#Set port num
$port = "-p" . $ARGV[1];

#in NT we use 1 netserver in different port for each test
# cause netserver exists after each client test
$nt = 0;
if ($#ARGV == 3){
  if ($ARGV[3] == "y") {
    $nt = 1;
  }
}

#every iteration mult the size of the message in this factor
$msg_mult_factor = 2;

for ($size = $min_send_size; $size <= $max_send_size; $size *= $msg_mult_factor){
  $msg_size = "-m" . "$size";
  @args = ($netperf,
	   $host, 
	   $port,
	   $test_type, 
	   $confidence1,
	   $confidence2,
	   $max_time,
	   "--", 
	   $msg_size,
	   $recv_sock_size,
	   $send_sock_size,
	   );
  print STDERR "@args \n";
  system(@args);
  if ($nt == 1) {
    $port++;
  }
}

# Alt + shift + 8 - remark region.





